# My GitLab Shared Runner
#
# Using Javier Santos docker image, mote his lowest loaded
# plaatform is 25 so we need to use that as the emulator
#  https://github.com/javiersantos/android-ci
# at some point will compose my own docker image with
# platform packages 21,22,23,24
#
# NOTE shared runners cannot execute x86 emulators as they
#      requried hardware acceleration so
#      on this shared runner example only doing BDD
#      tests
#
#      Other options to indie devs is the
#      free plan of Google's Firebase which is
#        10 virtual device tests per day
#         5 device tests per day
image: javiersantos/android-ci:28.0.3

variables:
  ANDROID_COMPILE_SDK: "28"
  ANDROID_BUILD_TOOLS: "28.0.3"

# only need to run build and tests as
# qa is setup to auto run on the build
stages:
  - build
  - test


before_script:
  - echo y | /sdk/tools/bin/sdkmanager "emulator" --sdk_root=/sdk
  - export GRADLE_USER_HOME=`pwd`/.gradle
  - chmod +x ./gradlew

build_job:
  stage: build
  # need it this way
  script:
    -  ./gradlew build
  tags:
    - linux
  artifacts:
    name: "$CI_JOB_NAME_$CI_COMMIT_REF_NAME_CI_COMMIT_SHORT_SHA"
    when: always
    paths:
      - build/
      - app/build/


bdd_tests:
  stage: test
  script:
    - ./gradlew app:testDebugUnitTest

  tags:
    - linux
  artifacts:
    name: "reports_bdd_$CI_PROJECT_NAME_$CI_BUILD_REF_NAME-$CI_COMMIT_SHORT_SHA"
    when: always
    paths:
      - app/build/reports/
      - app/build/outputs/



